#include <vector>
#include <time.h>
#include <Windows.h>
#include <iostream>

#include <fstream>
#include "interface.h"
#include "astro2.h"

#include "astrostuff.h"
#include "tarotstuff.h"

/* when connecting a bot to this code all channel tells and querries 
if you want to include querries 
has to be sent to 
void AstroInterface::processIrcChannel(char *p, char *mychannel, bool dotarot)
which is in this file.  p is the contents of the channel tell, 
i.e. mike sends 'hi' to the channel then
p="hi"; and mychannel can be a person or channel like adammr or #astrology.  
mychannel is who is responded to via the privmess command.
the processIrcChannel function is the function that calls all other functions in these
files.

Make sure you have the dll for astro calculating available at 
www.astro.com/swisseph linked to your project.
*/



/**
/* queryTime constructor. Initializes all the values to default values.
/* parameters none
/* @return none
*/

queryTime::queryTime(){
		day=0;
		month=0;
		year=0;
		day2=0;
		month2=0;
		year2=-1000;
		lat=-1000;
		latmin=0;
		latdeg=0;
		lon=-1000;
		londeg=0;
		lonmin=0;
		hour=-1;
		minute=-1;
		hour2=-1;
		minute2=-1;
		maxplanets=11;
		minplanets=0;
		system='P';

}

/**
/* Function reads a string breaks it into its space seperated components
/* and sends the blocks to processvalue to see what values it can find
/* ie is there a date, is there 2 dates.
/* @param p  represents the string or query from the user.
/* @param selection an int that is 1 or 0.  If its 1 a latitude or longitude have to be 
/* found to return sucess.
/* @return returns -1 for failure to find enough info to do a query
/* returns 0 for sucess, returns 1-4 if a planet range ( all or inner planets ect) is 
/* specified.  returns 10 for minor aspects no range and 11-14 for minor with 
/* a planet range.
*/

int queryTime::readString(const char *p, int selection)
{
		int maxtop=250;
		char myString[250][500];
		int myTop=0;
		int newline=1;
		int cc=0, aa=0;
	
		for(aa=0; aa<maxtop; aa++)
			myString[aa][0]='\0';
		
		for(aa=0; *(p+aa)!='\0'; aa++)
		{  if(aa>0)
			{
				if(*(p+aa)==' ' && *(p+aa-1)==' ')
					continue;
			}
			else
				if(*(p+aa)==' ')
					continue;
			if(newline==1)
			{
				newline=0;	
				myTop++;
				cc=aa;
			}
			if(*(p+aa)!=' ')
			{
				myString[myTop-1][aa-cc]=*(p+aa);
			}
			else
			{
				newline=1;
				myString[myTop-1][aa-cc]='\0';

			}


		}

		if(myTop>0)
			myString[myTop-1][aa-cc]='\0';
		else 
			printf("\nmytop is %d", myTop);
		printf("\n have set mystring[][]");

		int idate1=0, *date1=&idate1, idate2=0, *date2=&idate2, itime1=0, *time1=&itime1, itime2=0, *time2=&itime2;
		int ilocationlat=0, *locationlat=&ilocationlat, ilocationlon=0, *locationlon=&ilocationlon, iminor=0, *minor=&iminor, iplanetstype=0;
		int iplanetrange=0, *planetrange=&iplanetrange;
		

		for(aa=0; aa<myTop; aa++)
		{
			processValue(myString[aa], date1, date2, time1, time2, locationlat, locationlon, minor, planetrange, aa );
		}
		// check flags and return a value
	
		printf("\nyear=%d month=%d, day=%d, hour=%d, minute=%d, lat=%f, lon=%f", year, month, day, hour, minute, lat, lon);
		printf("\nyear2=%d month2=%d day2=%d hour2=%d minute2=%d", year2, month2, day2, hour2, minute2);


		if(hour!=-1 && minute!=-1)
			thetime= ( double ) (hour+ (double) minute/60);
		else
		{
			time_t rawtime;
			tm * ptm;
			time ( &rawtime );
			ptm = gmtime ( &rawtime );
			thetime= (double) (ptm->tm_hour+(double)ptm->tm_min/60);
			
		}
		if(hour2!=-1 && minute2!=-1)
			thetime2= ( double ) (hour2+ (double) minute2/60);
		else
		{
			time_t rawtime;
			tm * ptm;
			time ( &rawtime );
			ptm = gmtime ( &rawtime );
			thetime2= (double) (ptm->tm_hour+(double)ptm->tm_min/60);
			
		}
		
		if(selection==1)
		{
			int go=1;
			if(*date1==0)
				go=0;
			if(*time1==0)
				go=0;
			if(lat==-1000)
				go=0;
			if(lon==-1000)
				go=0;
			if(go==0)
				return -1;
			else
				return 0;
		}

			
		
		if(*date1==0)
			return -1;
		printf("\nreturn %d", *minor * 10 + *planetrange);

		return *planetrange+*minor*10;

}

/**
/* A function that analyzes each space seperated block to see if it can find 
/* one or two dates, one or two times and a longitude and latitude.
/* if a name is found it will look up the name in the file and see if it can find 
/* associated info for that name. For every found name there will be a date, time, 
/* longitude and latitude
/* @param date1  function sets this to 1 if it finds a date.
/* @param date2 function sets this to 1 if it finds a date and allready has a date.
/* @param time1 function sets this to 1 if it finds a time.
/* @param time2 function sets this to 1 if it finds a time and has a time.
/* @param locationlat function sets this to 1 if it finds a latitude.
/* @param locationlon function sets this to 1 if its finds a longitude
/* @param minor function sets this to 1 if it finds the string minor 
/* indicating they want minor aspects.
/* @param planetrange  is 0 by default and set to 1-4 depending on if 
/* inner (1) outer (2) asteroid (3) or all ( 4) is found.
/* @param place the place in the entire string. Example Mike Likes Cats.  Mike is in place 0 
/* and Cats is place 2.  A name is always in the place 1 spot.
/* @return none
*/

void queryTime::processValue(char mystring[], int *date1, int *date2, int *time1, int *time2, int *locationlat, int *locationlon, int *minor, int *planetrange, int place)
{
		if(*date1==0)
			if(isdate(mystring))
			{
				getdate(mystring, 1, date1);
				return;
			}

		if(*date2==0)
			if(isdate(mystring))
			{
				getdate(mystring, 2, date2);
				return;
			}
		if(*time1==0 && *date2==0)
			if(istime(mystring))
			{
				gettime(mystring, 1, time1);
				return;
			}

		if(*time2==0 && *date2==1)
			if(istime(mystring))
			{	printf("\nin here");
				gettime(mystring, 2, time2);
				return;
			}

		if(*locationlat==0)
			if(istime(mystring))
			{
				getlatlon(mystring, 1, locationlat);
				return;
			}

		if(*locationlon==0)
			if(istime(mystring))
			{
				getlatlon(mystring, 2, locationlon);
				return;
			}
			if(!strcmp(mystring, "inner"))
			{
				*planetrange=1;
				return;
			}

			if(!strcmp(mystring, "outer"))
			{
				*planetrange=2;
				return;
			}

			if(!strcmp(mystring, "asteroid"))
			{
				*planetrange=3;
				return;
			}
			if(!strcmp(mystring, "all"))
			{
				*planetrange=4;
				return;
			}
			if(!strcmp(mystring, "minor"))
			{
				*minor=1;
				return;
			}
			if(!strcmp(mystring, "k"))
			{
				system='U';
				return;
			}

			
			if(place==1)
				readFile(mystring, date1, time1, locationlat, locationlon);



		return;


}

/**
/* function determines if there is a valid date.  Currently doesnt check for much just that
/* there is  a '.' between 2 values but can be made to check for valid numbers.
/* @param p a string that represents the text to check.
/* @return none.
*/

int queryTime::isdate(char *p)
{
		char temp[1000];
		int a;

		for(a=0; *(p+a)!='\0' && *(p+a)!='.'; a++)
			temp[a]=*(p+a);

		temp[a]='\0';

		// day=atoi(temp);
		if(*(p+a)!='.')
			return 0;
				

		int b=a+1;
		for(a=b; *(p+a)!='\0' && *(p+a)!='.'; a++)
			temp[a-b]=*(p+a);
		temp[a-b]='\0';
		// month=atoi(temp);
		if(*(p+a)!='.')
			return 0;
		b=a+1;

		for(a=b; *(p+a)!='\0' && *(p+a)!=' '; a++)
			temp[a-b]=*(p+a);
		temp[a-b]='\0';
		// year=atoi(temp);
	return 1;
}

/**
/* function determines if there is a valid time. Since longitude and latitude are in 
/* same format is also used to check for long/lat. Currently doesnt check for much just that
/* there is  a ':' between 2 values but can be made to check for valid numbers.
/* @param p a string that represents the text to check.
/* @return none.
*/

int queryTime::istime(char *p)
{
		char temp[1000];
		int a;

		for(a=0; *(p+a)!='\0' && (*(p+a)!=':' && *(p+a)!='.'); a++)
			temp[a]=*(p+a);
		temp[a]='\0';
		// hour=atoi(temp);
		if(*(p+a)!=':' && *(p+a)!='.')
			return 0;
		int b=a+1;
		
		for(a=b; *(p+a)!='\0' && *(p+a)!=':'; a++)
			temp[a-b]=*(p+a);
		temp[a-b]='\0';
		// minute=atoi(temp);
		
	return 1;
}

/**
/* Function looks at a string and stores the month/day/year values 
/* in the query time object.
/* @param p the string to look at.
/* @param type when set to 1 it stors the values in the first date variables
/* i.e. day not day2.
/* @param date3 a pointer that can be date1 or date2 the function doesnt care.
/* that is set to 1 to indicate that date1 or date2 was found.
/* @return none.
*/

void queryTime::getdate(char *p, int type, int *date3)
{
		char temp[1000];
		int a;

		for(a=0; *(p+a)!='\0' && *(p+a)!='.'; a++)
			temp[a]=*(p+a);

		temp[a]='\0';

		if(type==1)
			day=atoi(temp);
		else
			day2=atoi(temp);

		if(*(p+a)!='.')
			return;
				

		int b=a+1;
		for(a=b; *(p+a)!='\0' && *(p+a)!='.'; a++)
			temp[a-b]=*(p+a);
		temp[a-b]='\0';
		if(type==1)
			month=atoi(temp);
		else
			month2=atoi(temp);
		
		
		if(*(p+a)!='.')
			return;
		b=a+1;

		for(a=b; *(p+a)!='\0' && *(p+a)!=' '; a++)
			temp[a-b]=*(p+a);
		temp[a-b]='\0';
		if(type==1)
			year=atoi(temp);
		else
			year2=atoi(temp);

		*date3=1;

}

/**
/* Function looks at a string and stores the hour minute values 
/* in the query time object.
/* @param p the string to look at.
/* @param type when set to 1 it stors the values in the first time variables
/* i.e. hour not hour2.
/* @param time3 a pointer that can be time1 or time2 the function doesnt care.
/* that is set to 1 to indicate that time1 or time2 was found.
/* @return none.
*/

void queryTime::gettime(char *p, int type, int *time3)
{	
		char temp[1000];
		int a;

		for(a=0; *(p+a)!='\0' && (*(p+a)!=':' && *(p+a)!='.'); a++)
			temp[a]=*(p+a);
		temp[a]='\0';
		if(type==1)
			hour=atoi(temp);
		if(type==2)
			hour2=atoi(temp);

		if(*(p+a)!=':' && *(p+a)!='.')
			return;
		int b=a+1;
		
		for(a=b; *(p+a)!='\0' && *(p+a)!=':'; a++)
			temp[a-b]=*(p+a);
		temp[a-b]='\0';
		if(type==1)
			minute=atoi(temp);
		if(type==2)
			minute2=atoi(temp);

		*time3=1;
		
}

/**
/* Function looks at a string and stores the latitude or longitude values.  
/* wether it stores a latitude or longitude depends on the type variable.
/* @param p the string to look at.
/* @param type type is 1 if its looking for a latitude and not 1 otherwise.
/* @param location passed by reference and to the calling function its 
/* locationlat or locationlon but to this function it doesnt care.
/* @return none
*/

void queryTime::getlatlon(char *p, int type, int *location)
{
	char temp[1000];
	int a, b;

	if(type==1)
	{
				for(a=0; *(p+a)!='\0' && *(p+a)!=':' ; a++)
					temp[a]=*(p+a);
				temp[a]='\0';
				double lat1=atoi(temp);
				if(*(p+a)!=':')
					return;
				printf("\nlat1=%f", lat1);

				b=a+1;
				for(a=b; *(p+a)!='\0'; a++)
					temp[a-b]=*(p+a);
				temp[a-b]='\0';
				double lat2=atoi(temp);
				printf("\nlat2=%f", lat2);

				if(lat1>=0)
					lat=lat1+lat2/60;
				else 
					lat=lat1-lat2/60;
				}
	else
	{
				
				
				for(a=0; *(p+a)!='\0' && *(p+a)!=':' ; a++)
					temp[a]=*(p+a);
				temp[a]='\0';
				double lon1=atoi(temp);
				printf("\nlon1=%f", lon1);
				if(*(p+a)!=':')
					return;
				b=a+1;
				for(a=b; *(p+a)!='\0' && *(p+a)!=' ' ; a++)
					temp[a-b]=*(p+a);
				temp[a-b]='\0';
				double lon2=atoi(temp);
				printf("\nlon2=%f", lon2);
				if(lon1>=0)
					lon=lon1+lon2/60;
				else
					lon=lon1-lon2/60;
	}

	*location=1;
}

/**
/* Function reduces a string to lowercase. the string in this case is the name its looking
/* up in readfile
/* parameters none
/* @return none.
*/

void makeNameLower(char *thename)
{
	for(int i=0; *(thename+i)!='\0'; i++)
		if(*(thename+i)>64 && *(thename+i)<91)
			*(thename+i)+=32;
}

/**
/* Function opens a file and looks to see if the name sent matches a name in the file.
/* the name sent is made lowercase since all names in the file are lowercase.
/* if it finds the name it stors the date/time/lat/lon info that corresponds to the 
/* name in the file and sets the appropriate variables to indicate this info
/* was found. It can also find and match the phrase now which means the current 
/* date and time is used.
/* @param p the string which is the name its looking for.
/* @param date1  set to 1 to indicate a date was found if the lookup is succesfull.
/* @param time1 set to 1 to indicate a time was found if the lookup is successfull.
/* @param locationlat set to 1 to indicate a latitude was found if the lookup is succesfull.
/* @param locationlon set to 1 to indicate a longitude was found if the lookup is successfull.
/* @return returns 0 for sucess and -1 if nothing is found.
*/

int queryTime::readFile(char *p, int *date1, int *time1, int *locationlat, int *locationlon){
		int bb;
		char rname[1000];
		rname[0]='\0';
		makeNameLower(p);

			for(bb=0; *(p+bb)!='\0'; bb++)
				rname[bb]=*(p+bb);

			rname[bb]='\0';

		if(!strcmp(p, "now"))
		{
			time_t rawtime;
			tm * ptm;
			time ( &rawtime );
			ptm = gmtime ( &rawtime );
			day=ptm->tm_mday;
			month=ptm->tm_mon+1;
			year=ptm->tm_year+1900;
			hour=ptm->tm_hour;
			minute=ptm->tm_min;
			*date1=1;
			*time1=1;
			return 0;
		}

		

		std::ifstream inFile("birthdata.txt", std::ios::in);

		if(!inFile)
			return -1;
		char  record[1000];
		record[0]='\0';
		
		int i=0;
		int found=0;
		while(inFile >> record)
		{
			if(found==1){
				if(i==0)
					day=atoi(record);
				if(i==1)
					month=atoi(record);
				if(i==2)
					year=atoi(record);
				if(i==3)
					hour=atoi(record);
				if(i==4)
					minute=atoi(record);
				if(i==5)
					latdeg=atoi(record);
				if(i==6)
					latmin=atoi(record);
				if(i==7)
					londeg=atoi(record);
				if(i==8)
					lonmin=atoi(record);




			i++;
			if(i==9)
				break;

			}

		if(!strcmp(record, rname))
		{	
			found=1;
			*date1=1;
			*time1=1;
			*locationlat=1;
			*locationlon=1;
		}
		}// end for

        if(i==9 && found==1)
		{
			thetime=(double) hour+(double) minute/60;
			if(londeg>=0)
				lon=londeg+lonmin/60;
			else
				lon=londeg-lonmin/60;
			if(latdeg>=0)
				lat=latdeg+latmin/60;
			else
				lat=latdeg-latmin/60;

			return 0;
		}
		return -1;

}

/** 
/* Function sets the values for minplanets and maxplanets depending on what 
/* type is sent to it.
/* @param type a value from 1-4 that will set to one of 4 ranges of planets to
/* inquire about.
/* @return none
*/

void queryTime::setMinMaxPlanets(int type)
{
	// minplanets/maxplanets have a default value
	// in the constructor.
	if(type==1)
	{
		maxplanets=5;
		minplanets=0;
	}
	if(type==2)
	{
		maxplanets=10;
		minplanets=5;
	}
	if(type==3)
	{
		minplanets=10;
		maxplanets=17;
	}
	if(type==4)
	{
		minplanets=0;
		maxplanets=18;
	}

	
}

/**
/* Function is a constructor for the astro interface class.  It initializes the 
/* random number generator to a spot based on the time. Sets the time and last shout 
/* time to now and this can be used if you want to make the bot send periodic messages
/* to a channel and sets the default wait time in ms ( 1200 ms) for sending tells
/* to irc.
/* parameters none
/* @return none
*/

AstroInterface::AstroInterface()
{
		srand ( time(NULL) );
		l_mytime=time(NULL);
		l_shouttime=time(NULL);
		wait=1200;
}	

/**
/* Function displays the current UTC time zone time to the channel or nick
/* inquiring.
/* @param mychannel a string that represnents who to send the time info to. can be 
/* a room or nick.
/* @return none.
*/

void AstroInterface::showtime(char *mychannel)
{

		time_t rawtime;
		tm * ptm;
		time ( &rawtime );
		ptm = gmtime ( &rawtime );
		int hour=ptm->tm_hour;
		int minute=ptm->tm_min;
		int day=ptm->tm_mday;
		int month=ptm->tm_mon+1;
		int year=ptm->tm_year+1900;
		if(minute>9)
			Sendf("PRIVMSG %s :%d.%d.%d %d:%d UTC\r\n", mychannel, day, month, year, hour, minute);
		else
			Sendf("PRIVMSG %s :%d.%d.%d %d:0%d UTC\r\n", mychannel, day, month, year, hour, minute);
		Sleep(wait);
		

}


/** 
/* this is the main function that gets called by the irc bot. it sends every tell or message 
/* to this function and this function figures out if what is typed is a command and 
/* then what function to call to process it.
/* @param p a string that represents the body of the tell. i.e. mike says hi there 
/* and p is hi  there.
/* @param mychannel.  a string that is who to respond to. can be a nick or room.
/* @param dotarot  if true it will look for tarot querries and if 
/* false it will return before having a chance to do that and the bot wont do tarot.
/* @return none
*/


void AstroInterface::processIrcChannel(char *p, char *mychannel, bool dotarot)
{

		Astro myAstro;
		Tarot myTarot;
		char timebuf[256];
		char datebuf[256];
		char *n="nobody";
		char m=*mychannel;
		_strtime( timebuf );
		_strdate(datebuf);
		if(m!='#')
			printf("\ntell from %s says: %s %s %s", mychannel, p, timebuf, datebuf);
				
		

		bool ignore=ignoreList.isListed(n);
		if(ignore)
			return;

		if(!strcmp(p, "!help"))
		{
					if(!spamGuard(n,m))
					return;

			help(mychannel);
		}
		if(!strcmp(p, "!time"))
		{
					if(!spamGuard(n,m))
					return;

			showtime(mychannel);
		}

		if(!strcmp(p, "!planets"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  1, false, mychannel, 0);
		}
		if(!strcmp(p, "!planets inner"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  1, false, mychannel, 1);
		}

		if(!strcmp(p, "!planets outer"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  1, false, mychannel, 2);
		}

		if(!strcmp(p, "!planets asteroid"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  1, false, mychannel, 3);
		}
		if(!strcmp(p, "!planets all"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  1, false, mychannel, 4);
		}

		if(!strcmp(p, "!aspects"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  5, false, mychannel, 0);
		}
		if(!strcmp(p, "!transits"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  5, false, mychannel, 0);
		}

		if(!strcmp(p, "!aspects inner"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  5, false, mychannel, 1);
		}

		if(!strcmp(p, "!aspects outer"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  5, false, mychannel, 2);
		}



		if(!strcmp(p, "!aspects asteroid"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  5, false, mychannel, 3);
		}

		if(!strcmp(p, "!aspects all"))
		{
					if(!spamGuard(n,m))
					return;

			myAstro.ircplanets(n, p,  5, false, mychannel, 4);
		}






		if(strlen(p)>7)
		{
				if(*(p)=='!' && *(p+1)=='p' &&  *(p+2)=='l' &&  *(p+3)=='a' &&  *(p+4)=='n' && *(p+5)=='e' &&  *(p+6)=='t' &&  *(p+7)=='s' &&  *(p+8)==' ' ) 
				{
					if(!spamGuard(n,m))
					return;


				myAstro.ircplanets(n,p, 1, true, mychannel, 0);
				}

				if(*(p)=='!' && *(p+1)=='c' &&  *(p+2)=='h' &&  *(p+3)=='a' &&  *(p+4)=='r' && *(p+5)=='t' &&  *(p+6)==' ') 
				{
					if(!spamGuard(n,m))
					return;


				myAstro.ircplanets(n,p, 2, true, mychannel, 0);
				}


				if(*(p)=='!' && *(p+1)=='a' &&  *(p+2)=='s' &&  *(p+3)=='p' &&  *(p+4)=='e' && *(p+5)=='c' &&  *(p+6)=='t' &&  *(p+7)=='s' &&  *(p+8)==' ' ) 
				{
					if(!spamGuard(n,m))
					return;


				myAstro.ircplanets(n,p, 5, true, mychannel, 0);
				}
				if(*(p)=='!' && *(p+1)=='t' &&  *(p+2)=='r' &&  *(p+3)=='a' &&  *(p+4)=='n' && *(p+5)=='s' &&  *(p+6)=='i' &&  *(p+7)=='t' &&  *(p+8)=='s' && *(p+9)==' ' ) 
				{

					if(!spamGuard(n,m))
					return;


				myAstro.ircplanets(n,p, 6, true, mychannel, 0);
				}
				if(*(p)=='!' && *(p+1)=='h' &&  *(p+2)=='o' &&  *(p+3)=='u' &&  *(p+4)=='s' && *(p+5)=='e' &&  *(p+6)=='s' &&  *(p+7)==' ') 
				{
					if(!spamGuard(n,m))
					return;

 
				myAstro.writeHouses(n, p, mychannel, 'P');
				}

				if(*(p)=='!' && *(p+1)=='k' &&  *(p+2)=='r' &&  *(p+3)=='u' &&  *(p+4)=='s' && *(p+5)=='i' &&  *(p+6)=='n' &&  *(p+7)=='s' && *(p+8)=='k' &&  *(p+9)=='i' &&  *(p+10)==' ') 
				{
					if(!spamGuard(n,m))
					return;


				myAstro.writeHouses(n, p, mychannel, 'U');
				}

		}

		if(!dotarot)
			return;
		if(!strcmp(mychannel, "#astrology"))
			return;

		if(!strcmp(p, "!draw"))
			{
				
				if(!spamGuard(n,m))
					return;

				myTarot.notdraw(n, mychannel);
			  }



		if(!strcmp(p, "!draw m"))
			{
				
				if(!spamGuard(n,m))
					return;
				myTarot.notdrawM(n, mychannel);


			}



		if(strlen(p)>6)
		{
			if(*(p)=='!' && *(p+1)=='c' && *(p+2)=='a' && *(p+3)=='r' && *(p+4)=='d' && *(p+5)==' ')
			{
				if(!spamGuard(n,m))
					return;
				myTarot.notcard(n, mychannel, p);
				return;
			}// end !card
		}// end if strlen(p)>6


	if(strlen(p)==7)
		if(*(p)=='!' && *(p+1)=='d' && *(p+2)=='r' && *(p+3)=='a' && *(p+4)=='w' && *(p+5)==' ')
		{
				
			if(!spamGuard(n,m))
				return;
			myTarot.spread((const char *) p, (const char *) n, mychannel, false);
			return;
		}

	if(strlen(p)==9)
			if(*(p)=='!' && *(p+1)=='d' && *(p+2)=='r' && *(p+3)=='a' && *(p+4)=='w' && *(p+5)==' ' && *(p+8)=='m')
			{
				if(!spamGuard(n,m))
					return;
				myTarot.spread((const char *) p,(const char *) n, mychannel, true);
				return;
			}


} // end function

/** 
/* Function counts the number of tells to the bot that it responds to in so many minutes.
/* if a internal value settable in this function is exceeded it will stop responding.
/* i.e. 15 tells in 4 minutes. Since tells and room tells have different limits if it 
/* finds a # i.e. #astrology as all rooms start with # it calls and returns the value from
/* shoutspamguard.
/* @param n a name currently not used but could be used to find the name of the person sending 
/* the tell to the bot.  
/* @param m the first character of mychannel and if it's '#' then shoutspamguard is called.
/* @return returns true if the bot can repsond and false if the limit is exceeded.
*/

bool AstroInterface::spamGuard(const char *n, char m)
{
		
		if(m=='#')
			return shoutspamGuard(n);

		
		char timebuf[256];
		char datebuf[256];
		_strtime( timebuf );
		_strdate(datebuf);

	long a=time(NULL);
	int max_tells=30;
	if(v_channel_tells.size()>max_tells-1)
	{
		//spam code --- true means go
		printf("\n channel tells > maxtells");
		printf("\n time %d and value %d \n", a, v_channel_tells[v_channel_tells.size()-max_tells]);

		if(v_channel_tells[v_channel_tells.size()-max_tells]+240<a)
		{
			v_channel_tells.push_back(a);
			return true;
		}
		else
		{
			// Sendf("tell %s max channel tells (%d) in 300 seconds exceeded\n", n, max_tells);
			printf("\n tell limit exceeded %s %s %s", n, timebuf, datebuf);
			return false;
		}

	}
	
		v_channel_tells.push_back(a);
		return true;

	
}

/** 
/* Function counts the number of tells to the bot that it responds to in so many minutes.
/* if a internal value settable in this function is exceeded it will stop responding.
/* i.e. 15 tells in 4 minutes. This function checks the number of tells to the 
/* current room in last few minutes.
/* @param n a name currently not used but could be used to find the name of the person sending 
/* the tell to the bot.  
/* @return returns true if the bot can repsond and false if the limit is exceeded.
*/

bool AstroInterface::shoutspamGuard(const char *n)
{
		char timebuf[256];
		char datebuf[256];
		_strtime( timebuf );
		_strdate(datebuf);

	long a=time(NULL);
	int max_tells=15;
	if(v_shout_tells.size()>max_tells-1)
	{
		int maxseconds=210;
		if(v_shout_tells[v_shout_tells.size()-max_tells]+maxseconds<a)
		{
			v_shout_tells.push_back(a);
			return true;
		}
		else
		{
			// Sendf("tell %s max channel tells (%d) in %d seconds exceeded\n", n, max_tells, maxseconds);
			printf("\n channel limit exceeded %s %s %s", n, timebuf, datebuf);
			return false;
		}

	}
	
		v_shout_tells.push_back(a);
		return true;

	
}

/**
/* Function sends a series of tells that give help on how to use the bot to users.
/* @param mychannel a string that is who to send the help to. Can be a room or 
/* nick
/* @return none.
*/

void AstroInterface::help(char *mychannel)
 {
	 char *temp="Commands '!planets' '!planets d.m.y h:m' '!planets inner' !planets outer' '!planets asteroid' '!planets all' '!aspects' '!aspects d.m.y h:m'";

	 Sendf("PRIVMSG %s :%s\r\n", mychannel, temp);
	 Sleep(wait);
	 temp="'!transits d.m.y h:m' also 'd.m.y h:m d.m.y h:m'   where the first date/time is birthdate and the second is the day you want transits for.  '!houses d.m.y h:m +-latdeg:latmin +-longdeg:longmin'";
	 Sendf("PRIVMSG %s :%s\r\n", mychannel, temp);
	 Sleep(wait);
	 temp="!chart d.m.y h:m +-latdeg:latmin +-londeg:lonmin,  !planets and !aspects will work with a latdeg:latmin londeg:longmin argument if you add them after the time.  Finnaly there is !time to see the current UTC time for time converstions. Remember UTC doesnt observe daylights saving time.";
	 Sendf("PRIVMSG %s :%s\r\n", mychannel, temp);
 }




