#include <vector>
#include <iostream>
#include <fstream>
#include <windows.h>
#include <time.h>
#include "tarotstuff.h"
#include "interface.h"
#include "astro2.h"

/**
/* Destructor. clears the arrays.
/* no parameters.
/* @return none
*/

Tarot::~Tarot()
{
		v_deck.clear();
		v_links.clear();
		v_cards.clear();
}

/**	
/* Constructor. Initializes 3 vectors. One contains the cards v_deck, one contains
/* the links v_links and one contains the cards number which can be a roman numeral
/* or an integer for the lower cards. v_cards. Also wait ( the time to pause 
/* when sending stuff to irc) is set here.
/* no parameters.
/* @return none.
*/

Tarot::Tarot()
{
		v_deck.push_back("I The Mountebank, The Juggler, The Magician");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/magician.shtml");
		v_cards.push_back("i");

		v_deck.push_back("II The High Priestess");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/highpriestess.shtml");
		v_cards.push_back("ii");
		
		v_deck.push_back("III. The Empress");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/empress.shtml");
		v_cards.push_back("iii");
		
		v_deck.push_back("IV The Emperor");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/emperor.shtml");
		v_cards.push_back("iv");
		
		v_deck.push_back("V The Hierophant");
		v_cards.push_back("v");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/hierophant.shtml");

		v_deck.push_back("VI The Lovers");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/lovers.shtml");
		v_cards.push_back("vi");

		v_deck.push_back("VII The Chariot");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/chariot.shtml");
		v_cards.push_back("vii");

		v_deck.push_back("VIII Justice");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/justice.shtml");
		v_cards.push_back("viii");

		v_deck.push_back("IX The Hermit");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/hermit.shtml");
		v_cards.push_back("ix");

		v_deck.push_back("X The Wheel of Fortune");
		v_cards.push_back("x");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/wheel.shtml");

		v_deck.push_back("XI Strength, or Fortitude");
		v_cards.push_back("xi");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/strength.shtml");

		v_deck.push_back("XII The Hanged Man");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/hangedman.shtml");
		v_cards.push_back("xii");

		v_deck.push_back("XIII Death");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/death.shtml");
		v_cards.push_back("xiii");

		v_deck.push_back("XIV Temperance");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/temperance.shtml");
		v_cards.push_back("xiv");

		v_deck.push_back("XV The Devil");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/devil.shtml");
		v_cards.push_back("xv");

		v_deck.push_back("XVI The Tower");
		v_cards.push_back("xvi");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/tower.shtml");

		v_deck.push_back("XVII The Star");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/star.shtml");
		v_cards.push_back("xvii");

		v_deck.push_back("XVIII The Moon");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/moon.shtml");
		v_cards.push_back("xviii");

		v_deck.push_back("XIX The Sun");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/sun.shtml");
		v_cards.push_back("xix");

		v_deck.push_back("XX Judgement");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/judgement.shtml");
		v_cards.push_back("xx");

		v_deck.push_back("XXI The World");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/world.shtml");
		v_cards.push_back("xxi");

		v_deck.push_back("The Fool");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/fool.shtml");
		v_cards.push_back("xxii");

		v_deck.push_back("Ace of Wands");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/aces.shtml");
		v_deck.push_back("Ace of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/aces.shtml");
		v_deck.push_back("Ace of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/aces.shtml");
		v_deck.push_back("Ace of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/aces.shtml");

        v_deck.push_back("Two of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/twos.shtml");
		v_deck.push_back("Two of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/twos.shtml");
		v_deck.push_back("Two of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/twos.shtml");
		v_deck.push_back("Two of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/twos.shtml");

        v_deck.push_back("Three of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/threes.shtml");
		v_deck.push_back("Three of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/threes.shtml");
		v_deck.push_back("Three of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/threes.shtml");
		v_deck.push_back("Three of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/threes.shtml");

        v_deck.push_back("Four of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/fours.shtml");
		v_deck.push_back("Four of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/fours.shtml");
		v_deck.push_back("Four of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/fours.shtml");
		v_deck.push_back("Four of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/fours.shtml");

        v_deck.push_back("Five of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/fives.shtml");
		v_deck.push_back("Five of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/fives.shtml");
		v_deck.push_back("Five of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/fives.shtml");
		v_deck.push_back("Five of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/fives.shtml");

        v_deck.push_back("Six of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/sixes.shtml");
		v_deck.push_back("Six of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/sixes.shtml");
		v_deck.push_back("Six of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/sixes.shtml");
		v_deck.push_back("Six of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/sixes.shtml");

        v_deck.push_back("Seven of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/sevens.shtml");
		v_deck.push_back("Seven of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/sevens.shtml");
		v_deck.push_back("Seven of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/sevens.shtml");
		v_deck.push_back("Seven of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/sevens.shtml");

        v_deck.push_back("Eight of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/eights.shtml");
		v_deck.push_back("Eight of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/eights.shtml");
		v_deck.push_back("Eight of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/eights.shtml");
		v_deck.push_back("Eight of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/eights.shtml");

        v_deck.push_back("Nine of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/nines.shtml");
		v_deck.push_back("Nine of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/nines.shtml");
		v_deck.push_back("Nine of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/nines.shtml");
		v_deck.push_back("Nine of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/nines.shtml");

        v_deck.push_back("Ten of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/tens.shtml");
		v_deck.push_back("Ten of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/tens.shtml");
		v_deck.push_back("Ten of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/tens.shtml");
		v_deck.push_back("Ten of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/tens.shtml");

        v_deck.push_back("Page of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/pages.shtml");
		v_deck.push_back("Page of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/pages.shtml");
		v_deck.push_back("Page of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/pages.shtml");
		v_deck.push_back("Page of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/pages.shtml");

        v_deck.push_back("Knight of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/knights.shtml");
		v_deck.push_back("Knight of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/knights.shtml");
		v_deck.push_back("Knight of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/knights.shtml");
		v_deck.push_back("Knight of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/knights.shtml");

        v_deck.push_back("Queen of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/queens.shtml");
		v_deck.push_back("Queen of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/queens.shtml");
		v_deck.push_back("Queen of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/queens.shtml");
		v_deck.push_back("Queen of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/queens.shtml");

        v_deck.push_back("King of Wands");		
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/kings.shtml");
		v_deck.push_back("King of Cups");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/kings.shtml");
		v_deck.push_back("King of Swords");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/kings.shtml");
		v_deck.push_back("King of Pentacles");
		v_links.push_back("http://www.aeclectic.net/tarot/learn/meanings/kings.shtml");
		wait=1200;

}

/**
/* Function draws a spread of tarot cards from eathier the trump, first 22 
/* cards or the whole deck, 78 cards and sends the spread string to irc.
/* @param p  a char pointer that contains the original string of the request made by 
/* the user.  Its parsed to find out how many cards they want to draw. You can draw
/* 1-7 cards.
/* @param n a pointer that contains the name of the person drawing. currently not implemented 
/* in the irc bot but was used in the chessclub bot.
/* @param mychannel  a char string that is who to send the reply to. Can be a handle or 
/* channel.
/* @param major  true if they want to only draw from the major arcana or trump. first 22 cards.
/* @return none
*/

void Tarot::spread(const char *p, const char *n, char *mychannel, bool major)
{
			char timebuf[256];
			char datebuf[256];
			_strtime( timebuf );
			_strdate(datebuf);
			int num=0, ii, jj;
			int numbers[99];
			char temp[2];
			char *temp2=  new char[500]; temp2[0]='\0';
			char *temp3=  new char[500];temp3[0]='\0';
			int decktop=78;
			if(major)
				decktop=22;


			if(*(p)=='!' && *(p+1)=='d' && *(p+2)=='r' && *(p+3)=='a' && *(p+4)=='w' && *(p+5)==' ')
			{
				temp[0]=*(p+6);
				temp[1]='\0';
				num=atoi(temp);
				bool go=false;
				

				if(num>0 && num<8)
				{

					// draw cards
					for(ii=0; ii<num; ii++)
					{
					
					int choice=rand()%decktop;
					numbers[ii]=choice;
					for(jj=0; jj<ii; jj++)
					{
						if(numbers[jj]==choice)
							ii--;
					}// end jj
					}// end ii

					for(ii=0; ii<num; ii++)
					{
					
						temp2=strcat(temp3, v_deck[numbers[ii]]);
						if(ii<num-1)
						{
							temp2=strcat(temp3, ";");
							temp2=strcat(temp3, " ");
						}
						go=true;
					}
					printf("\n name is %s, spread string is: %s %s %s", n, temp2, timebuf, datebuf);
					Sendf("PRIVMSG %s :%s\r\n", mychannel, temp2 );
					Sleep(wait);
					

				}  // end if num >0 <8
			}// end if !draw

}


/**
/* Function draws one card from the full deck and sends the response 
/* to the person or channel.
/* @param n a name, not used but could be if the name was parsed.
/* @param mychannel a string that represents who to respond to.
/* can be a nick or channel.
/* @return none
*/

void Tarot::notdraw(char *n, char *mychannel)
{
				int a=rand()%78;
		        Sendf("PRIVMSG %s :%s\r\n", mychannel, v_deck[a]);
				Sleep(wait);
				printf("\n%s tarot draw , response: %s\n", n, v_deck[a]);
}

/**
/* Function draws one card from the trump only and sends the response 
/* to the person or channel.
/* @param n a name, not used but could be if the name was parsed.
/* @param mychannel a string that represents who to respond to.
/* can be a nick or channel.
/* @return none
*/

void Tarot::notdrawM(char *n, char *mychannel)
{

				int a=rand()%22;
		        Sendf("PRIVMSG %s :%s\r\n", mychannel, v_deck[a]);
				Sleep(wait);
				// printf("\n%s %s", timebuf, datebuf);
				printf("\n%s tarot draw major , response: %s\n", n, v_deck[a]);
			
}

/**
/* Function used by notcard to garantee that requests for cards 
/* represented by roman numerals can be made with any capitilization. i.e. II Ii and ii
/* @param thestring represents the string to make all lowercase.
/* @return none.
*/


void makeStringLower(char *thestring)
{
	for(int i=0; *(thestring+i)!='\0'; i++)
		if(*(thestring+i)>64 && *(thestring+i)<91)
			*(thestring+i)+=32;
}

/**
/* Function reads a string and determines what info link to send back 
/* to the channel or person.  Since card queries can be both numbers and roman 
/* numerals the makestringlower function is used on the roman numerals.
/* @param n  a name currently not used.
/* @param mychannel the nick or channel to send the link back to.
/* @param p the original querry string which is parsed to find which card number
/* ( can be a number or roman numeral) to give a link for. the links are initialized 
/* in the constructor.
/* @return none
*/

void Tarot::notcard(char *n, char *mychannel, char *p)
{

				char num[3];
				char temp[800];
				num[0]=*(p+6);
				num[1]='\0';
			
				if(strlen(p)>7)
				{
					num[1]=*(p+7);
					num[2]='\0';
				}
				
				bool go=false;

				int number=atoi(num);
				if(number>0 && number<15)
				{

					Sendf("PRIVMSG %s :%s\r\n", mychannel, v_links[22+number*4-1] );
					Sleep(wait);
					// Sendf("tel 103 %s\n", v_links[22+number*4-1]);
					printf("\n channel link %s from %s \n", v_links[22+number*4-1], n);
					//printf("\n%s %s", timebuf, datebuf);
					go=true;
				}
				else{
					for(int d=6; *(p+d)!='\0'; d++)
						temp[d-6]=*(p+d);
					temp[d-6]='\0';
					makeStringLower(temp);

					for(d=0; d<22; d++)
					{
						if(!strcmp(temp, v_cards[d]))
						{

							Sendf("PRIVMSG %s :%s\r\n", mychannel, v_links[d] );
							Sleep(wait);
							//Sendf("tel 103 %s\n", v_links[d]);
							//printf("\n%s %s", timebuf, datebuf);
							printf("\n channel link %s from %s \n", v_links[d], n);
							go=true;
							break;

						} // end if


					} // end for d=0-22
				} // end else



				
				if(go==false) 
					printf("\n channel invalid number from %s\n", n);
				
			
}